(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     35046,        878]
NotebookOptionsPosition[     33557,        825]
NotebookOutlinePosition[     34216,        850]
CellTagsIndexPosition[     34173,        847]
WindowTitle->Bifurcation Diagrams with Flow Fields - Source
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["Bifurcation Diagrams with Flow Fields", "Section",
 CellFrame->{{0, 0}, {0, 0}},
 ShowCellBracket->False,
 FontColor->RGBColor[0.597406, 0, 0.0527047]],

Cell[CellGroupData[{

Cell[BoxData[
 GraphicsBox[RasterBox[CompressedData["
1:eJztnVuSozgWQDNiPqa3MJ+zpVlCbaB3WlGVNV9dvYH6TQRUph/ZGIHQmwvG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   "], {{0, 0}, {1800, 25}}, {0, 255},
   ColorFunction->RGBColor],
  ImageSize->{1800, 25},
  PlotRange->{{0, 1800}, {0, 25}}]], "Section",
 CellFrame->{{0, 0}, {0, 0}},
 ShowCellBracket->False],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"bifurcationPoints", "[", 
    RowBox[{"eqn_", ",", " ", "par_", ",", " ", "var_"}], "]"}], ":=", " ", 
   RowBox[{"Cases", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"par", ",", " ", "var"}], "}"}], "/.", 
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"D", "[", 
            RowBox[{"eqn", ",", " ", "var"}], "]"}], "\[Equal]", "0"}], ",", 
          " ", 
          RowBox[{"eqn", "\[Equal]", "0"}]}], "}"}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"var", ",", " ", "par"}], "}"}]}], "]"}]}], ",", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Except", "[", "_Complex", "]"}], ",", " ", 
       RowBox[{"Except", "[", "_Complex", "]"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.43819006309317*^9, 3.438190092146267*^9}, {
  3.4381902343559923`*^9, 3.438190243703329*^9}, {3.4382770658037767`*^9, 
  3.438277069229848*^9}},
 CellID->925053830],

Cell[BoxData[
 RowBox[{
  RowBox[{"equilibriumCurvePlots", "[", 
   RowBox[{"eqn_", ",", " ", 
    RowBox[{"{", 
     RowBox[{"par_", ",", " ", "parMin_", ",", " ", "parMax_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"var_", ",", " ", "varMin_", ",", " ", "varmax_"}], "}"}]}], 
   "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "bifPoints", ",", " ", "criticalPoints", ",", " ", "parRanges", ",", " ",
       "equilibriumBranches", ",", " ", "eigenValues", ",", " ", 
      "stabilityCharacteristics", ",", " ", "plotSegments"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"bifPoints", "=", 
      RowBox[{"bifurcationPoints", "[", 
       RowBox[{"eqn", ",", " ", "par", ",", " ", "var"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"criticalPoints", "=", " ", 
      RowBox[{"Union", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"parMin", ",", " ", "parMax"}], "}"}], ",", " ", 
        RowBox[{"bifPoints", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", " ", "1"}], "]"}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"parRanges", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{"criticalPoints", ",", " ", "2", ",", "1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"equilibriumBranches", "=", " ", 
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{"eqn", "\[Equal]", "0"}], ",", " ", "var"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"eigenValues", "=", 
      RowBox[{
       RowBox[{"D", "[", 
        RowBox[{"eqn", ",", " ", "var"}], "]"}], "/.", 
       "equilibriumBranches"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"stabilityCharacteristics", "=", 
      RowBox[{"Flatten", "@", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Re", "[", "#", "]"}], "\[LessEqual]", "  ", "0"}], ",", 
            " ", 
            RowBox[{"Dashing", "[", 
             RowBox[{"{", "}"}], "]"}], ",", " ", 
            RowBox[{"Dashing", "[", 
             RowBox[{"{", 
              RowBox[{"0.0025", ",", "0.01"}], "}"}], "]"}]}], "]"}], "&"}], 
         " ", ",", " ", 
         RowBox[{"Outer", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"#1", "/.", 
              RowBox[{"par", "\[Rule]", " ", "#2"}]}], ")"}], "&"}], ",", " ",
            "eigenValues", ",", " ", 
           RowBox[{"Mean", " ", "/@", "parRanges"}]}], "]"}], ",", " ", 
         RowBox[{"{", "2", "}"}]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"plotSegments", "=", 
      RowBox[{"Distribute", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"var", "/.", "equilibriumBranches"}], ",", " ", 
          "parRanges"}], "}"}], ",", " ", "List"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"MapThread", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Plot", "[", 
         RowBox[{
          RowBox[{"#1", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
          RowBox[{"Evaluate", "@", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "par", "}"}], ",", " ", 
             RowBox[{"#1", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], ",", 
          RowBox[{"PlotStyle", "\[Rule]", " ", 
           RowBox[{"{", 
            RowBox[{"Black", ",", " ", "Thick", ",", "#2"}], "}"}]}]}], "]"}],
         "&"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"plotSegments", ",", " ", "stabilityCharacteristics"}], 
        "}"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4380969793480883`*^9, 3.438097194950748*^9}, {
   3.438097228807952*^9, 3.4380972894467993`*^9}, {3.4380973549876833`*^9, 
   3.4380973613769484`*^9}, {3.43809744627388*^9, 3.438097468966318*^9}, {
   3.43809751155868*^9, 3.4380975355424547`*^9}, 3.438099108254416*^9, {
   3.438108425391724*^9, 3.43810843186132*^9}, {3.438108574091851*^9, 
   3.438108575298979*^9}, {3.438108675598472*^9, 3.438108677906901*^9}, 
   3.438181973744588*^9, {3.438183992346085*^9, 3.438183995048523*^9}, 
   3.438185536798868*^9, {3.438186248424942*^9, 3.43818628247138*^9}, {
   3.438187697683084*^9, 3.4381876981300497`*^9}, {3.438188438665887*^9, 
   3.438188477639986*^9}, {3.4381885216002283`*^9, 3.4381885477477617`*^9}, {
   3.438188695581002*^9, 3.438188713212578*^9}, {3.438188885671033*^9, 
   3.438188886609761*^9}, {3.43818926241047*^9, 3.438189263952683*^9}, {
   3.438189360571409*^9, 3.4381893894673767`*^9}, 3.43818945554151*^9, {
   3.4381902044390287`*^9, 3.4381902048593082`*^9}, {3.4382763654583*^9, 
   3.438276387307575*^9}},
 CellID->1745600177],

Cell[BoxData[
 RowBox[{
  RowBox[{"normalForms", "=", 
   RowBox[{"{", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\"\<saddle node bifurcation\>\"", ",", " ", 
       RowBox[{"\[Lambda]", "+", 
        SuperscriptBox["y", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<saddle node bifurcation\>\"", ",", " ", 
       RowBox[{"\[Lambda]", "-", 
        SuperscriptBox["y", "2"]}]}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"\"\<pitchfork bifurcation supercritical\>\"", ",", " ", 
       RowBox[{
        RowBox[{"\[Lambda]", " ", "y"}], "-", 
        SuperscriptBox["y", "3"]}]}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"\"\<pitchfork bifurcation subcritical\>\"", ",", " ", 
       RowBox[{
        RowBox[{"\[Lambda]", " ", "y"}], "+", 
        SuperscriptBox["y", "3"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<transcritical bifurcation\>\"", ",", " ", 
       RowBox[{
        RowBox[{"\[Lambda]", " ", "y"}], "-", 
        SuperscriptBox["y", "2"]}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.438182949895886*^9, 3.438182964905415*^9}, 
   3.438183047779064*^9, {3.438183113797544*^9, 3.4381831506507*^9}, {
   3.438183258954733*^9, 3.438183323432325*^9}, 3.4381836905630608`*^9, {
   3.438184096640164*^9, 3.438184134438882*^9}, {3.438184197626515*^9, 
   3.438184233173629*^9}, {3.4381842743387957`*^9, 3.438184355746698*^9}, {
   3.4381843900153227`*^9, 3.438184418357692*^9}, {3.438184514561598*^9, 
   3.438184526326076*^9}, {3.438184762220159*^9, 3.43818476578364*^9}, 
   3.438184825322301*^9, {3.4381905110204678`*^9, 3.438190515666833*^9}, {
   3.438276776253202*^9, 3.4382767804867573`*^9}, {3.4382772935433292`*^9, 
   3.438277314843769*^9}, {3.438364509610845*^9, 3.438364518421726*^9}, {
   3.5135021977545*^9, 3.513502267942*^9}, {3.513502394442*^9, 
   3.513502398270125*^9}},
 CellID->1528073172],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"eqn", "=", 
     RowBox[{"normalForms", "[", 
      RowBox[{"[", 
       RowBox[{"type", ",", " ", "2"}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"equilibriumPoints", "=", 
     RowBox[{"Quiet", "@", 
      RowBox[{"Thread", "[", 
       RowBox[{"{", 
        RowBox[{"par", ",", " ", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"y", "/.", 
            RowBox[{"Solve", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"eqn", "/.", 
                 RowBox[{"\[Lambda]", "\[Rule]", " ", "par"}]}], ")"}], 
               "\[Equal]", "0"}], ",", " ", "y"}], "]"}]}], ",", " ", 
           RowBox[{
            RowBox[{"Element", "[", 
             RowBox[{"#", ",", " ", "Reals"}], "]"}], "&"}]}], "]"}]}], "}"}],
        "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{"showStreamLines", ",", " ", 
        RowBox[{"StreamPlot", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", " ", "eqn"}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"\[Lambda]", ",", " ", 
            RowBox[{"-", "3"}], ",", " ", "3"}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"y", ",", " ", 
            RowBox[{"-", "3"}], ",", " ", "3"}], "}"}], ",", " ", 
          RowBox[{"StreamColorFunction", "\[Rule]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
              RowBox[{"Arg", "[", "#4", "]"}], "]"}], "&"}], ")"}]}], ",", 
          RowBox[{"StreamColorFunctionScaling", "\[Rule]", " ", "False"}]}], 
         "]"}], ",", " ", 
        RowBox[{"Plot", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Lambda]", ",", " ", 
            RowBox[{"-", "3"}], ",", " ", "3"}], "}"}]}], "]"}]}], "]"}], ",",
       " ", 
      RowBox[{"If", "[", 
       RowBox[{"showEC", ",", " ", 
        RowBox[{"equilibriumCurvePlots", "[", 
         RowBox[{"eqn", ",", " ", 
          RowBox[{"{", 
           RowBox[{"\[Lambda]", ",", " ", 
            RowBox[{"-", "3"}], ",", " ", "3"}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"y", ",", " ", 
            RowBox[{"-", "3"}], ",", " ", "3"}], "}"}]}], "]"}], ",", 
        RowBox[{"Plot", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Lambda]", ",", " ", 
            RowBox[{"-", "3"}], ",", " ", "3"}], "}"}]}], "]"}]}], "]"}], ",",
       " ", 
      RowBox[{"PlotRange", "\[Rule]", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "}"}]}], ",", " ", 
      RowBox[{"Axes", "\[Rule]", " ", "False"}], ",", " ", 
      RowBox[{"AspectRatio", "\[Rule]", " ", "1"}], ",", " ", 
      RowBox[{"PlotLabel", "\[Rule]", " ", 
       RowBox[{"Style", "[", 
        RowBox[{
         RowBox[{"ToString", "[", 
          RowBox[{"normalForms", "[", 
           RowBox[{"[", 
            RowBox[{"type", ",", " ", "1"}], "]"}], "]"}], "]"}], "<>", 
         "\"\<\\n equilibrium points: \>\"", "<>", " ", 
         RowBox[{"ToString", "[", "equilibriumPoints", "]"}]}], "]"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", " ", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"PointSize", "[", "Large", "]"}], ",", " ", 
           RowBox[{"Point", " ", "/@", "  ", "equilibriumPoints"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"PointSize", "[", "Large", "]"}], ",", "Brown"}], "}"}], 
         ",", " ", 
         RowBox[{"Point", " ", "/@", " ", 
          RowBox[{"bifurcationPoints", "[", 
           RowBox[{"eqn", ",", " ", "\[Lambda]", ",", " ", "y"}], "]"}]}]}], 
        "]"}]}], ",", 
      RowBox[{"Frame", "\[Rule]", " ", "True"}], ",", " ", 
      RowBox[{"FrameLabel", "\[Rule]", " ", 
       RowBox[{"{", 
        RowBox[{"\"\<\[Lambda]\>\"", ",", " ", 
         RowBox[{"Style", "[", 
          RowBox[{"\"\<y\>\"", ",", "Italic"}], "]"}]}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"400", ",", "400"}], "}"}]}]}], "]"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "type", ",", "3", ",", " ", 
       "\"\<\!\(\*FractionBox[\(d\[InvisibleSpace]y\), \
\(\(\[InvisibleSpace]\)\(d\[InvisibleSpace]t\)\)]\) =\>\""}], "}"}], ",", " ", 
     RowBox[{"Array", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Rule", "[", 
         RowBox[{"#", ",", " ", 
          RowBox[{"normalForms", "[", 
           RowBox[{"[", 
            RowBox[{"#", ",", "2"}], "]"}], "]"}]}], "]"}], "&"}], ",", " ", 
       RowBox[{"Length", "[", "normalForms", "]"}]}], "]"}], " ", ",", " ", 
     "PopupMenu"}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "par", ",", " ", "0", ",", " ", 
       "\"\<bifurcation parameter \[Lambda]\>\""}], "}"}], ",", " ", 
     RowBox[{"-", "3"}], ",", " ", "3", ",", 
     RowBox[{"Appearance", "\[Rule]", "\"\<Lab\neled\>\""}]}], "}"}], ",", 
   "  ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "showEC", ",", " ", "True", ",", " ", 
       "\"\<show equilibrium curves\>\""}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"True", ",", " ", "False"}], "}"}], ",", " ", "Checkbox"}], 
    "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "showStreamLines", ",", " ", "True", ",", " ", 
       "\"\<show streamlines\>\""}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"True", ",", " ", "False"}], "}"}], ",", " ", "Checkbox"}], 
    "}"}], ",", " ", "\[IndentingNewLine]", 
   RowBox[{"ControlPlacement", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Top", ",", " ", "Top", ",", " ", "Left", ",", " ", "Left"}], 
     "}"}]}], ",", 
   RowBox[{"SaveDefinitions", "\[Rule]", " ", "True"}], ",", 
   RowBox[{"TrackedSymbols", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.35696210375764*^9, 3.438278033594471*^9, {3.438364451268011*^9, 
   3.4383645004959335`*^9}, {3.438364531201004*^9, 3.4383645367265563`*^9}, {
   3.4383665589271755`*^9, 3.438366573192891*^9}, {3.438457293456669*^9, 
   3.438457293933449*^9}, 3.438457333842355*^9, {3.438457365467601*^9, 
   3.438457458127399*^9}, {3.4384575348751087`*^9, 3.438457535303442*^9}, {
   3.438458332372656*^9, 3.4384583353799562`*^9}, {3.438528091601673*^9, 
   3.438528111492425*^9}, {3.4385281504145494`*^9, 3.4385281518051834`*^9}, 
   3.438528333775098*^9}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`par$$ = 0, $CellContext`showEC$$ = 
    True, $CellContext`showStreamLines$$ = True, $CellContext`type$$ = 1, 
    Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`type$$], 3, 
       "\!\(\*FractionBox[\(d\[InvisibleSpace]y\), \(\(\[InvisibleSpace]\)\(d\
\[InvisibleSpace]t\)\)]\) ="}, {
      1 -> $CellContext`y^2 + $CellContext`\[Lambda], 
       2 -> -$CellContext`y^2 + $CellContext`\[Lambda], 
       3 -> -$CellContext`y^3 + $CellContext`y $CellContext`\[Lambda], 
       4 -> $CellContext`y^3 + $CellContext`y $CellContext`\[Lambda], 
       5 -> -$CellContext`y^2 + $CellContext`y $CellContext`\[Lambda]}}, {{
       Hold[$CellContext`par$$], 0, "bifurcation parameter \[Lambda]"}, -3, 
      3}, {{
       Hold[$CellContext`showEC$$], True, "show equilibrium curves"}, {
      True, False}}, {{
       Hold[$CellContext`showStreamLines$$], True, "show streamlines"}, {
      True, False}}}, Typeset`size$$ = {400., {198., 202.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    False, $CellContext`type$19515$$ = False, $CellContext`par$19516$$ = 
    0, $CellContext`showEC$19517$$ = 
    False, $CellContext`showStreamLines$19518$$ = False}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`par$$ = 0, $CellContext`showEC$$ = 
        True, $CellContext`showStreamLines$$ = True, $CellContext`type$$ = 3},
       "ControllerVariables" :> {
        Hold[$CellContext`type$$, $CellContext`type$19515$$, False], 
        Hold[$CellContext`par$$, $CellContext`par$19516$$, 0], 
        Hold[$CellContext`showEC$$, $CellContext`showEC$19517$$, False], 
        Hold[$CellContext`showStreamLines$$, \
$CellContext`showStreamLines$19518$$, False]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, 
      "Body" :> ($CellContext`eqn = 
        Part[$CellContext`normalForms, $CellContext`type$$, 
          2]; $CellContext`equilibriumPoints = Quiet[
          Thread[{$CellContext`par$$, 
            Select[
             ReplaceAll[$CellContext`y, 
              Solve[
              ReplaceAll[$CellContext`eqn, $CellContext`\[Lambda] -> \
$CellContext`par$$] == 0, $CellContext`y]], Element[#, Reals]& ]}]]; Show[
         If[$CellContext`showStreamLines$$, 
          
          StreamPlot[{
           0, $CellContext`eqn}, {$CellContext`\[Lambda], -3, 
            3}, {$CellContext`y, -3, 3}, 
           StreamColorFunction -> (ColorData["TemperatureMap"][
             Arg[#4]]& ), StreamColorFunctionScaling -> False], 
          Plot[{}, {$CellContext`\[Lambda], -3, 3}]], 
         If[$CellContext`showEC$$, 
          $CellContext`equilibriumCurvePlots[$CellContext`eqn, {$CellContext`\
\[Lambda], -3, 3}, {$CellContext`y, -3, 3}], 
          Plot[{}, {$CellContext`\[Lambda], -3, 3}]], 
         PlotRange -> {{-3, 3}, {-3, 3}}, Axes -> False, AspectRatio -> 1, 
         PlotLabel -> Style[
           StringJoin[
            ToString[
             Part[$CellContext`normalForms, $CellContext`type$$, 1]], 
            "\n equilibrium points: ", 
            ToString[$CellContext`equilibriumPoints]]], Epilog -> Join[{
            PointSize[Large], 
            Map[Point, $CellContext`equilibriumPoints]}, {
            PointSize[Large], Brown}, 
           Map[Point, 
            $CellContext`bifurcationPoints[$CellContext`eqn, $CellContext`\
\[Lambda], $CellContext`y]]], Frame -> True, FrameLabel -> {"\[Lambda]", 
           Style["y", Italic]}, ImageSize -> {400, 400}]), 
      "Specifications" :> {{{$CellContext`type$$, 3, 
          
          "\!\(\*FractionBox[\(d\[InvisibleSpace]y\), \(\(\[InvisibleSpace]\)\
\(d\[InvisibleSpace]t\)\)]\) ="}, {
         1 -> $CellContext`y^2 + $CellContext`\[Lambda], 
          2 -> -$CellContext`y^2 + $CellContext`\[Lambda], 
          3 -> -$CellContext`y^3 + $CellContext`y $CellContext`\[Lambda], 
          4 -> $CellContext`y^3 + $CellContext`y $CellContext`\[Lambda], 
          5 -> -$CellContext`y^2 + $CellContext`y $CellContext`\[Lambda]}, 
         ControlType -> 
         PopupMenu}, {{$CellContext`par$$, 0, 
          "bifurcation parameter \[Lambda]"}, -3, 3, Appearance -> 
         "Lab\neled"}, {{$CellContext`showEC$$, True, 
          "show equilibrium curves"}, {True, False}, ControlType -> 
         Checkbox}, {{$CellContext`showStreamLines$$, True, 
          "show streamlines"}, {True, False}, ControlType -> Checkbox}}, 
      "Options" :> {
       ControlPlacement -> {Top, Top, Left, Left}, TrackedSymbols -> True}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{579., {258., 263.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    Initialization:>({$CellContext`eqn = $CellContext`y^3 + $CellContext`y \
$CellContext`\[Lambda], $CellContext`normalForms = {{
         "saddle node bifurcation", $CellContext`y^2 + \
$CellContext`\[Lambda]}, {
         "saddle node bifurcation", -$CellContext`y^2 + \
$CellContext`\[Lambda]}, {
         "pitchfork bifurcation supercritical", -$CellContext`y^3 + \
$CellContext`y $CellContext`\[Lambda]}, {
         "pitchfork bifurcation subcritical", $CellContext`y^3 + \
$CellContext`y $CellContext`\[Lambda]}, {
         "transcritical bifurcation", -$CellContext`y^2 + $CellContext`y \
$CellContext`\[Lambda]}}, $CellContext`equilibriumPoints = {{0, 0}, {0, 0}, {
        0, 0}}, $CellContext`equilibriumCurvePlots[
         Pattern[$CellContext`eqn, 
          Blank[]], {
          Pattern[$CellContext`par, 
           Blank[]], 
          Pattern[$CellContext`parMin, 
           Blank[]], 
          Pattern[$CellContext`parMax, 
           Blank[]]}, {
          Pattern[$CellContext`var, 
           Blank[]], 
          Pattern[$CellContext`varMin, 
           Blank[]], 
          Pattern[$CellContext`varmax, 
           Blank[]]}] := 
       Module[{$CellContext`bifPoints, $CellContext`criticalPoints, \
$CellContext`parRanges, $CellContext`equilibriumBranches, \
$CellContext`eigenValues, $CellContext`stabilityCharacteristics, \
$CellContext`plotSegments}, $CellContext`bifPoints = \
$CellContext`bifurcationPoints[$CellContext`eqn, $CellContext`par, \
$CellContext`var]; $CellContext`criticalPoints = 
          Union[{$CellContext`parMin, $CellContext`parMax}, 
            Part[$CellContext`bifPoints, All, 1]]; $CellContext`parRanges = 
          Partition[$CellContext`criticalPoints, 2, 
            1]; $CellContext`equilibriumBranches = 
          Solve[$CellContext`eqn == 
            0, $CellContext`var]; $CellContext`eigenValues = ReplaceAll[
            
            D[$CellContext`eqn, $CellContext`var], \
$CellContext`equilibriumBranches]; $CellContext`stabilityCharacteristics = 
          Flatten[
            Map[If[Re[#] <= 0, 
              Dashing[{}], 
              Dashing[{0.0025, 0.01}]]& , 
             Outer[
             ReplaceAll[#, $CellContext`par -> #2]& , \
$CellContext`eigenValues, 
              Map[Mean, $CellContext`parRanges]], {
             2}]]; $CellContext`plotSegments = Distribute[{
             
             ReplaceAll[$CellContext`var, $CellContext`equilibriumBranches], \
$CellContext`parRanges}, List]; MapThread[Plot[
            Part[#, 1], 
            Evaluate[
             Join[{$CellContext`par}, 
              Part[#, 2]]], 
            PlotStyle -> {
             Black, Thick, #2}]& , {$CellContext`plotSegments, \
$CellContext`stabilityCharacteristics}]], $CellContext`bifurcationPoints[
         Pattern[$CellContext`eqn, 
          Blank[]], 
         Pattern[$CellContext`par, 
          Blank[]], 
         Pattern[$CellContext`var, 
          Blank[]]] := Cases[
         ReplaceAll[{$CellContext`par, $CellContext`var}, 
          
          Solve[{D[$CellContext`eqn, $CellContext`var] == 0, $CellContext`eqn == 
            0}, {$CellContext`var, $CellContext`par}]], {
          Except[
           Blank[Complex]], 
          Except[
           Blank[Complex]]}], Attributes[PlotRange] = {ReadProtected}}; 
     Typeset`initDone$$ = True),
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["CAPTION", "Section",
 CellFrame->{{0, 0}, {1, 0}},
 CellFrameColor->RGBColor[0.87, 0.87, 0.87],
 FontFamily->"Helvetica",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->RGBColor[0.597406, 0, 0.0527047]],

Cell[TextData[{
 "Bifurcations indicate qualitative changes in a system's behavior. For a \
dynamical system ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FractionBox[
     RowBox[{"d", "\[InvisibleSpace]", "y"}], 
     RowBox[{"d", "\[InvisibleSpace]", "t"}]], "=", 
    RowBox[{"f", "(", 
     RowBox[{"y", ",", "\[Lambda]"}], ")"}]}], TraditionalForm]], 
  "InlineMath"],
 ", bifurcation points are those equilibrium points at which the Jacobian ",
 Cell[BoxData[
  FormBox[
   FractionBox[
    RowBox[{"\[PartialD]", "f"}], 
    RowBox[{"\[PartialD]", "y"}]], TraditionalForm]], "InlineMath"],
 " is singular. This Demonstration shows the bifurcation diagrams of several \
normal form bifurcations in one dimension. The bifurcation point, equilibrium \
points, and the flow of the vector field are visualized. The bifurcation is \
shown as a brown point. Solid black lines indicate stable equilibrium \
branches and dashed black lines indicate unstable ones. "
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["DETAILS", "Section",
 CellFrame->{{0, 0}, {1, 0}},
 CellFrameColor->RGBColor[0.87, 0.87, 0.87],
 FontFamily->"Helvetica",
 FontSize->12,
 FontWeight->"Bold",
 FontColor->RGBColor[0.597406, 0, 0.0527047]],

Cell[TextData[{
 "R. Seydel, ",
 StyleBox["Practical Bifurcation and Stability Analysis: From Equilibrium to \
Chaos",
  FontSlant->"Italic"],
 ", New York: Springer-Verlag, 1994."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["THIS NOTEBOOK IS THE SOURCE CODE FROM", "Text",
 CellFrame->{{0, 0}, {0, 0}},
 CellMargins->{{48, 10}, {4, 28}},
 CellGroupingRules->{"SectionGrouping", 25},
 CellFrameMargins->{{48, 48}, {6, 5}},
 CellFrameColor->RGBColor[0.87, 0.87, 0.87],
 FontFamily->"Helvetica",
 FontSize->10,
 FontWeight->"Bold",
 FontColor->RGBColor[0.597406, 0, 0.0527047]],

Cell[TextData[{
 "\"",
 ButtonBox["Bifurcation Diagrams with Flow Fields",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://demonstrations.wolfram.com/BifurcationDiagramsWithFlowFields/\
"], None},
  ButtonNote->
   "http://demonstrations.wolfram.com/BifurcationDiagramsWithFlowFields/"],
 "\"",
 " from ",
 ButtonBox["the Wolfram Demonstrations Project",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://demonstrations.wolfram.com/"], None},
  ButtonNote->"http://demonstrations.wolfram.com/"],
 "\[ParagraphSeparator]\[NonBreakingSpace]",
 ButtonBox["http://demonstrations.wolfram.com/\
BifurcationDiagramsWithFlowFields/",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://demonstrations.wolfram.com/BifurcationDiagramsWithFlowFields/\
"], None},
  ButtonNote->
   "http://demonstrations.wolfram.com/BifurcationDiagramsWithFlowFields/"]
}], "Text",
 CellMargins->{{48, Inherited}, {0, Inherited}},
 FontFamily->"Verdana",
 FontSize->10,
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Contributed by: ",
 ButtonBox["Suba Thomas",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://demonstrations.wolfram.com/author.html?author=Suba+Thomas"], 
    None},
  ButtonNote->
   "http://demonstrations.wolfram.com/author.html?author=Suba+Thomas"]
}], "Text",
 CellDingbat->"\[FilledSmallSquare]",
 CellMargins->{{66, 48}, {2, 4}},
 FontFamily->"Verdana",
 FontSize->10,
 FontColor->GrayLevel[0.6]],

Cell[TextData[{
 "A full-function Wolfram ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " system (Version 6 or higher) is required to edit this notebook.\n",
 StyleBox[ButtonBox["GET WOLFRAM MATHEMATICA \[RightGuillemet]",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/products/mathematica/"], None},
  ButtonNote->"http://www.wolfram.com/products/mathematica/"],
  FontFamily->"Helvetica",
  FontWeight->"Bold",
  FontSlant->"Italic",
  FontColor->RGBColor[1, 0.42, 0]]
}], "Text",
 CellFrame->True,
 CellMargins->{{48, 68}, {8, 28}},
 CellFrameMargins->12,
 CellFrameColor->RGBColor[0.87, 0.87, 0.87],
 CellChangeTimes->{3.3750111182355957`*^9},
 ParagraphSpacing->{1., 1.},
 FontFamily->"Verdana",
 FontSize->10,
 FontColor->GrayLevel[0.411765],
 Background->RGBColor[1, 1, 1]],

Cell[TextData[{
 "\[Copyright] ",
 StyleBox[ButtonBox["Wolfram Demonstrations Project & Contributors",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://demonstrations.wolfram.com/"], None},
  ButtonNote->"http://demonstrations.wolfram.com/"],
  FontColor->GrayLevel[0.6]],
 "\[ThickSpace]\[ThickSpace]\[ThickSpace]|\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
 StyleBox[ButtonBox["Terms of Use",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://demonstrations.wolfram.com/termsofuse.html"], None},
  ButtonNote->"http://demonstrations.wolfram.com/termsofuse.html"],
  FontColor->GrayLevel[0.6]],
 "\[ThickSpace]\[ThickSpace]\[ThickSpace]|\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
 StyleBox[ButtonBox["Make a new version of this Demonstration \
\[RightGuillemet]",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://demonstrations.wolfram.com/participate/upload.jsp?id=\
BifurcationDiagramsWithFlowFields"], None},
  ButtonNote->None],
  FontColor->GrayLevel[0.6]]
}], "Text",
 CellFrame->{{0, 0}, {0, 0.5}},
 CellMargins->{{48, 10}, {20, 50}},
 CellFrameMargins->{{6, 0}, {6, 6}},
 CellFrameColor->GrayLevel[0.6],
 FontFamily->"Verdana",
 FontSize->9,
 FontColor->GrayLevel[0.6]]
}, Open  ]]
},
Editable->True,
Saveable->False,
ScreenStyleEnvironment->"Working",
CellInsertionPointCell->None,
WindowSize->{777, 650},
WindowMargins->{{Inherited, Inherited}, {Inherited, 0}},
WindowElements->{
 "StatusArea", "MemoryMonitor", "MagnificationPopUp", "VerticalScrollBar", 
  "MenuBar"},
WindowTitle->"Bifurcation Diagrams with Flow Fields - Source",
DockedCells->{},
CellContext->Notebook,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[617, 21, 157, 3, 66, "Section"],
Cell[CellGroupData[{
Cell[799, 28, 3700, 64, 37, "Section"],
Cell[4502, 94, 1060, 30, 72, "Input",
 InitializationCell->True,
 CellID->925053830],
Cell[5565, 126, 4831, 114, 312, "Input",
 InitializationCell->True,
 CellID->1745600177],
Cell[10399, 242, 1921, 41, 77, "Input",
 InitializationCell->True,
 CellID->1528073172],
Cell[12323, 285, 6998, 178, 421, "Input"],
Cell[19324, 465, 8705, 180, 538, InheritFromParent]
}, Open  ]],
Cell[CellGroupData[{
Cell[28066, 650, 209, 6, 62, "Section"],
Cell[28278, 658, 975, 23, 70, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[29290, 686, 209, 6, 32, "Section"],
Cell[29502, 694, 192, 6, 70, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[29731, 705, 355, 9, 20, "Text",
 CellGroupingRules->{"SectionGrouping", 25}],
Cell[30089, 716, 993, 29, 34, "Text"],
Cell[31085, 747, 430, 14, 18, "Text"],
Cell[31518, 763, 815, 24, 98, "Text"],
Cell[32336, 789, 1205, 33, 88, "Text"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
(* NotebookSignature LQ4yDdTjx1IhoCDc76T2ShvV *)
